/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: alloc_frame_list.c,v $
 *
 * $Log: alloc_frame_list.c,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

#include <stdio.h>

#include "defs.h"
#include "types.h"
#include "protos.h"

/*
 * Returns a newly allocated and initialized FRAME_LIST pointer
 *
 * Input: none
 * Output: pointer to allocated memory
 */

/* Large number (for bounding box init) */
#define HUGEBB 1.0e30

FRAME_LIST *alloc_frame_list( )
{

   FRAME_LIST *cur_frame;

   FRAME_INFO *cur_info;


   cur_frame = (FRAME_LIST *) acquire( sizeof(FRAME_LIST) );

   if (cur_frame == NULL) return( cur_frame );

   cur_frame->prev = NULL;
   cur_frame->next = NULL;

   cur_info = (FRAME_INFO *) acquire( sizeof(FRAME_INFO) );

   if (cur_info == NULL) return( NULL );

   cur_frame->info = cur_info;
   cur_frame->atoms = NULL;
   cur_frame->bonds = NULL;

/* Clear the frame info */

   cur_info->sequence = 0;
   cur_info->bb_xmin = HUGEBB;
   cur_info->bb_xmax = -HUGEBB;
   cur_info->bb_ymin = HUGEBB;
   cur_info->bb_ymax = -HUGEBB;
   cur_info->bb_zmin = HUGEBB;
   cur_info->bb_zmax = -HUGEBB;

   return( cur_frame );

}

/* end of alloc_frame_list.cxx */
