#include "vtkTextSource.h"
#include "vtkPolyDataMapper.h"

#include "defs.h"
#include "types.h"
#include "protos.h"

extern int num_elements;
extern vtkPolyDataMapper **labelMappers;

// Create the label mapper objects.
void create_labels(DRAW_FLAGS *flags, ELEMENT_LIST *element){
  int i;

  // Create a text(label) source for each element
  vtkTextSource **labelSource = (vtkTextSource **) malloc(4 * num_elements);
  for(i = 0; i < num_elements; ){
    // There are 4 special elements that need to be skipped
    if(strncmp(element->label, BACKG_LABEL, LABEL_LEN) != 0 &&
       strncmp(element->label, BONDC_LABEL, LABEL_LEN) != 0 &&
       strncmp(element->label, AXISC_LABEL, LABEL_LEN) != 0 &&
       strncmp(element->label, FRMCT_LABEL, LABEL_LEN) != 0 ){

      labelSource[i] = vtkTextSource::New();
      labelSource[i]->SetText(element->label);
      labelSource[i]->BackingOff();

      i++;
    }
    element = element->next;
  }

  // Create the mapper objects
  labelMappers = (vtkPolyDataMapper **) malloc(4 * num_elements);
  for(int i = 0; i < num_elements; i++){
    labelMappers[i] = vtkPolyDataMapper::New();
    labelMappers[i]->SetInput(labelSource[i]->GetOutput());
    labelSource[i]->Delete();
  }


}


