/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: defs.h,v $
 *
 * $Log: defs.h,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

/* use this flag for IBM */
/* #define IBM_VERS */

/* General purpose stuff */

#ifdef MOVIE
#define PROGNAME "RotMovie"
#else
#define PROGNAME "RotMole"
#endif

#define VERSION "5.0 - VTK"

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define ABS(x) ((x) > 0 ? (x) : -(x) )

/* Die when out of memory */
#define Check_ptr(x) if (x == NULL) exit(-1)

/* maximum options in the environment variable */
#define MAX_ENV_OPTS 100

/* maximum characters in an atom label */
#define LABEL_LEN 4

/* labels used for colors */
#define BACKG_LABEL "BK"
#define BONDC_LABEL "BD"
#define AXISC_LABEL "AX"
#define FRMCT_LABEL "FC"

/* undefined atom details */
#define UNDEF_ATOM_RADIUS	1.0
#define UNDEF_ATOM_BONDING 	false
#define UNDEF_ATOM_RED		1.0
#define UNDEF_ATOM_GREEN	1.0
#define UNDEF_ATOM_BLUE		0.0
#define UNDEF_ATOM_MATERIAL	-1

/* Some standard colors */

#define CBLACK 0x000000 /* Black */
#define MENUFG 0x00ffff /* Bright Yellow */
#define MENUBG 0x6f6f00 /* Dark Cyan */
#define CLOCKD 0x4f007f /* Dark Red-Magenta */

/* bond material index */

#define BOND_MAT 4096

/* sphere complexities */

#define NORM_SPH 0
#define GOOD_SPH 1
#define BEST_SPH 2

/* bond complexities */

#define LINE_BOND 0
#define STRC_BOND 1
#define TAPC_BOND 2

/* cursors */

#define NORMAL_CURSOR GLUT_CURSOR_INHERIT
#define WAIT_CURSOR   GLUT_CURSOR_WAIT
#define ROTATE_CURSOR GLUT_CURSOR_CYCLE
#define ZOOM_CURSOR   GLUT_CURSOR_CROSSHAIR

/* for video output */

#define VIDEO_XRES 360
#define VIDEO_YRES 360

/* error reporting */

#define ERROR_MSG(infunct, errmsg) \
   fprintf(stderr, "Error in %s: %s\n", infunct, errmsg)


#define HI_RES_CYL    4
#define MED_RES_CYL    5
#define LO_RES_CYL    6

/* MATRIX modes */
#define MSINGLE                 0
#define MPROJECTION             1
#define MVIEWING                2
#define MTEXTURE                3

typedef float Matrix[4][4];

/* end of defs.h */
