/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: find_element.c,v $
 *
 * $Log: find_element.c,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

#include <stdio.h>
#include <string.h>

#include "defs.h"
#include "types.h"
#include "protos.h"

/*
 * This routine either finds an existing element in the list
 * that matches the given label, or it creates a new element
 * for that label. In either case, it returns a pointer to 
 * the element. 
 *
 * Input: Start of element list, label to match
 * Output: Pointer to element found/created
 */


ELEMENT_LIST *find_element(ELEMENT_LIST *head, char *label)
{

   ELEMENT_LIST *current,*last;

   current = head;
   last = head;

   while (current != NULL) {

      if (strcmp(current->label,label)==0) {
         return(current);
      }

      last = current;
      current = current->next;

   }

   last->next = (ELEMENT_LIST *) acquire ( sizeof( ELEMENT_LIST ) ) ;
   current = last->next;

   if (current == NULL) {
      ERROR_MSG("find_element","Out of Memory");
      exit(-1);
   }

   current->label = (char *) acquire( LABEL_LEN+1 );

   if (current->label == NULL) {
      ERROR_MSG("find_element","Out of Memory");
      exit(-1);
   }

   strcpy(current->label,label);

   current->radius = UNDEF_ATOM_RADIUS;
   current->can_bond = UNDEF_ATOM_BONDING;
   current->color.red = UNDEF_ATOM_RED;
   current->color.green = UNDEF_ATOM_GREEN;
   current->color.blue = UNDEF_ATOM_BLUE;
   current->material = UNDEF_ATOM_MATERIAL;
   current->next = NULL;

   return(current);

}

/* end of find_element.cxx */
