/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: get_first_model.c,v $
 *
 * $Log: get_first_model.c,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

#include <stdio.h>
#include <string.h>

#include "defs.h"
#include "types.h"
#include "protos.h"

/*
 * This routine opens the given coordinate file, or stdin if
 * no file is given. The print file name is updated is necessary,
 * and the opened file is passed to the file parser.
 *
 * Input: file names, element list, frame list, flags
 * Output: frame list from the file
 */

void get_first_model(FILE_INFO *filenames, ELEMENT_LIST *element_head,
                     FRAME_LIST **frame_head, FRAME_LIST **frame_tail,
                     DRAW_FLAGS *flags)
{

   FILE *ifil = NULL;

   char *pathless;

   if (filenames->position_fname == NULL) {

      ifil = stdin;
      set_string( &(filenames->position_fname), "stdin");
      set_string( &(filenames->print_fname), "rmprint" );

   } else {

      ifil = my_fopen(filenames->position_fname, "rb");
      if (ifil == NULL) {
        fprintf(stderr,"Failed to open %s, quitting.\n",
                filenames->position_fname);
        exit(-1);
      }

      pathless = strrchr( filenames->position_fname, '/' );

      if (pathless == NULL) 
         pathless = filenames->position_fname;
      else
         pathless++;

      set_string( &(filenames->print_fname), pathless );
      set_string( &(filenames->position_fname), filenames->print_fname );

   }

   fprintf(stderr,"Reading model from %s\n",filenames->position_fname);

   rmf_reader( ifil, element_head, frame_head, frame_tail, flags ); 

   if (ifil != stdin) fclose(ifil);

}


/* end of get_first_model.cxx */
