/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: get_first_table.c,v $
 *
 * $Log: get_first_table.c,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

#include <stdio.h>

#include "defs.h"
#include "types.h"
#include "protos.h"

/*
 * This routine opens either a given table file, or tries
 * to find one if none is given. It then runs the file parser 
 * to read in the element list.
 *
 * Input: file name list, existing element list
 * Output: element list will be changed, file name might be.
 */

/* these are the names of the files that will be searched */
#define TRY1 "./.rmtable"
#define TRY2 "~/.rmtable"
#define TRY3 "/usr/share/rotmovie/.rmtable"


void get_first_table( FILE_INFO *filenames, ELEMENT_LIST *head )
{

   FILE *ifil = NULL;


   if (filenames->element_fname != NULL) {

/* open the file. if it doesn't exist, drop through to the */
/* next stage                                              */

     ifil = my_fopen(filenames->element_fname, "rt");
     if (ifil == NULL) {
       fprintf(stderr,"Failed to open %s, trying defaults.\n",
               filenames->element_fname);
     }

   }

/* if no file has been opened, try the defaults */

   if (ifil == NULL) {

     ifil = my_fopen( TRY1, "rt" );
     if (ifil != NULL) 
       set_string( &(filenames->element_fname), TRY1 );
     else {

       ifil = my_fopen( TRY2, "rt" );
       if (ifil != NULL) 
         set_string( &(filenames->element_fname), TRY2 );
       else {

         ifil = my_fopen( TRY3, "rt" );
         if (ifil != NULL) 
           set_string( &(filenames->element_fname), TRY3 );
         else {

           fprintf(stderr, "Failed to open any table file.\n");

         }

       }

     }

   }

/* if a file has been opened, read it */

   if (ifil != NULL) {

      fprintf(stderr,"Reading table from %s\n",filenames->element_fname);

      rmtable_reader( ifil, head );

      fclose( ifil );

   }

}

/* end of get_first_table.cxx */
