/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: get_max_radius.c,v $
 *
 * $Log: get_max_radius.c,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

#include <stdio.h>

#include "defs.h"
#include "types.h"
#include "protos.h"

/*
 * This routine finds the (approximate) maximum radius of the model.
 *
 * Input: frame list, flags
 * Output: flags->max_radius
 */

/* a coding short cut */
#define RMAX(x,y) x = (x > y ? x : y )

void get_max_radius( FRAME_LIST *head, DRAW_FLAGS *flags )
{

  float rmax=0.0;

  FRAME_LIST *cur;


  for (cur=head; cur != NULL; cur=cur->next) {

    RMAX(rmax, ABS(cur->info->bb_xmin) );
    RMAX(rmax, ABS(cur->info->bb_xmax) );
    RMAX(rmax, ABS(cur->info->bb_ymin) );
    RMAX(rmax, ABS(cur->info->bb_ymax) );
    RMAX(rmax, ABS(cur->info->bb_zmin) );
    RMAX(rmax, ABS(cur->info->bb_zmax) );

  }

  flags->max_radius = rmax;

}

/* end of get_max_radius.cxx */
