#include "vtkRenderer.h"
#include "vtkPolyDataMapper.h"
#include "vtkActor.h"
#include "vtkSphereSource.h"
#include "vtkAxes.h"
#include "vtkLineSource.h"
#include "vtkTransform.h"

#include "defs.h"
#include "types.h"
#include "protos.h"

extern int num_elements;
extern vtkPolyDataMapper *axesMapper;
extern vtkPolyDataMapper **sphereMappers;
extern vtkPolyDataMapper *bondMappers[2];
extern vtkPolyDataMapper *lineMapper;

void init_actors(vtkRenderer *ren, DRAW_FLAGS *flags, FRAME_LIST *frame, ELEMENT_LIST *element_head){
  

  // Draw the coordinate axes
  if(flags->show_axis) draw_axes(ren);
  
  // Create the actors for each of the atoms
  if(flags->draw_atoms) draw_atoms(ren, flags, frame);

  // Create the actors for each of the bonds
  if(flags->draw_bonds) draw_bonds(ren, flags, frame, element_head);
  
  // Create the actors for each of the atom labels
  if(flags->show_chr_labs) draw_atom_labels(ren, flags, frame->atoms);

  // Create the actors for each of the isosurfaces
  //if(flags->draw_surfaces) draw_isosurfaces(ren);
}
