/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: init_element_list.c,v $
 *
 * $Log: init_element_list.c,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

#include <stdio.h>
#include <string.h>

#include "defs.h"
#include "types.h"
#include "protos.h"

/*
 * this code generates a beginning element list, including the 
 * background color, axis color, bond color, and frame counter color
 * items as needed. 
 *
 * Input: place to put element list, drawing flags
 * Output: new element list, with basic elements defined
 */


void init_element_list( ELEMENT_LIST **head, DRAW_FLAGS flags )
{

   ELEMENT_LIST *current;

/* Background Element */

   current = (ELEMENT_LIST *) acquire( sizeof(ELEMENT_LIST) );

   if (current == NULL) {
      ERROR_MSG("init_element_list","Out of Memory");
      exit(-1);
   }

   *head = current;

   current->label = (char *) acquire( LABEL_LEN+1 );

   if (current->label == NULL) {
      ERROR_MSG("init_element_list","Out of Memory");
      exit(-1);
   }

   strcpy(current->label,BACKG_LABEL);

   current->radius = UNDEF_ATOM_RADIUS;
   current->can_bond = UNDEF_ATOM_BONDING;
   current->color = flags.back_color;
   current->material = UNDEF_ATOM_MATERIAL;
   current->next = NULL;

/* Bond Color Element */

   current->next = (ELEMENT_LIST *) acquire( sizeof(ELEMENT_LIST) );
   current = current->next;

   if (current == NULL) {
      ERROR_MSG("init_element_list","Out of Memory");
      exit(-1);
   }

   current->label = (char *) acquire( LABEL_LEN+1 );

   if (current->label == NULL) {
      ERROR_MSG("init_element_list","Out of Memory");
      exit(-1);
   }

   strcpy(current->label,BONDC_LABEL);

   current->radius = UNDEF_ATOM_RADIUS;
   current->can_bond = UNDEF_ATOM_BONDING;
   current->color = flags.bond_color;
   current->material = UNDEF_ATOM_MATERIAL;
   current->next = NULL;


/* Axis Color Element 

   current->next = (ELEMENT_LIST *) acquire( sizeof(ELEMENT_LIST) );
   current = current->next;

   if (current == NULL) {
      ERROR_MSG("init_element_list","Out of Memory");
      exit(-1);
   }

   current->label = (char *) acquire( LABEL_LEN+1 );

   if (current->label == NULL) {
      ERROR_MSG("init_element_list","Out of Memory");
      exit(-1);
   }

   strcpy(current->label,AXISC_LABEL);

   current->radius = UNDEF_ATOM_RADIUS;
   current->can_bond = UNDEF_ATOM_BONDING;
   current->color = flags.axis_color;
   current->material = UNDEF_ATOM_MATERIAL;
   current->next = NULL;
*/
#ifdef MOVIE 

/* Frame Counter Color Element 

   current->next = (ELEMENT_LIST *) acquire( sizeof(ELEMENT_LIST) );
   current = current->next;

   if (current == NULL) {
      ERROR_MSG("init_element_list","Out of Memory");
      exit(-1);
   }

   current->label = (char *) acquire( LABEL_LEN+1 );

   if (current->label == NULL) {
      ERROR_MSG("init_element_list","Out of Memory");
      exit(-1);
   }

   strcpy(current->label,FRMCT_LABEL);

   current->radius = UNDEF_ATOM_RADIUS;
   current->can_bond = UNDEF_ATOM_BONDING;
   current->color = flags.cntr_color;
   current->material = UNDEF_ATOM_MATERIAL;
   current->next = NULL;
*/
#endif

}

/* end of init_element_list.cxx */
