#include "vtkAxes.h"
#include "vtkPolyDataMapper.h"

#include "defs.h"
#include "types.h"
#include "protos.h"

extern vtkPolyDataMapper *axesMapper;

// Create all the needed mapper objects. 
void init_mappers(DRAW_FLAGS *flags, ELEMENT_LIST *element_head){
  ELEMENT_LIST *elements;

  // Create the coordinate axes mapper
  vtkAxes *axes = vtkAxes::New();
    axes->SetScaleFactor(flags->max_radius);
  axesMapper = vtkPolyDataMapper::New();
    axesMapper->SetInput(axes->GetOutput());

  axes->Delete();

  // Create a sphere source and mapper for each element
  elements = element_head;
  create_spheres(flags, elements);

  // Create the bond sources and mappers
  create_bonds(flags);

  // Create the label sources and mappers
  create_labels(flags, elements);

}
