/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: my_fopen.c,v $
 *
 * $Log: my_fopen.c,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "defs.h"
#include "types.h"
#include "protos.h"

/*
 * This attempts to expand a leading '~' in a file's path, then opens
 * the file.
 *
 * Input: file name, file mode
 * Output: pointer to file structure
 */

FILE * my_fopen( char *fname, char *fmode )
{

   FILE *handle;

   char *homestr = NULL;
   char *newname = NULL;
   char *index = NULL;


/* pass through files without leading '~' */

   if (fname[0] != '~') {
     handle = fopen( fname, fmode );
     return( handle );
   }

/* if we can't find HOME, we have to pass it through */

   if ((homestr = getenv("HOME")) == NULL) {
     handle = fopen( fname, fmode );
     return( handle );
   }

   if (fname[1] != '/') {

/* difficult case: ~user/... */
     index = strrchr(homestr,'/');
     if (index != NULL) index[1] = 0;
   }

   newname = (char *) acquire( strlen(homestr) + strlen(fname) );

   if (newname == NULL) {
     handle = fopen( fname, fmode );
     return( handle );
   }

   strcpy(newname, homestr);
   strcat(newname, &fname[1]);

   handle = fopen( newname, fmode );

   free( newname );

   return( handle );

}

/* end of my_fopen.cxx */
