/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: option_parser.c,v $
 *
 * $Log: option_parser.c,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "defs.h"
#include "types.h"
#include "protos.h"

#ifndef IBM_VERS
#include <getopt.h>
#endif

/*
 * This routine parses the given list of arguments for command-line
 * options, and sets the flags accordingly.
 *
 * Input: count of arguments, list of arguments, pointer to flags,
 *        pointer to file names, source of option list
 * Output: changed flags and file names
 */

#define opt_error(x) fprintf(stderr,"Bad option to %c in %s\n",x,opt_source)

void option_parser(int argc, char **argv, DRAW_FLAGS *flags, 
                   FILE_INFO *filenames, char *opt_source)
{

   int optc, number;

   while ((optc = 
     getopt(argc, argv, "Bh:m:t:F:K:S:X:")) != -1) {
     if (strchr("KSX",optc) != NULL) {
       if (sscanf(optarg, "%d", &number) != 1) {
         opt_error(optc);
         usage();
       }
     }

     switch (optc) {
       
       case 'h' :
               usage();
               break;

       case 'm' :
               set_string(&(filenames->matrix_fname),optarg);
               break;

       case 't' :
               set_string(&(filenames->element_fname),optarg);
               break;
             
       case 'B' : 
               flags->calc_bonds = false;
               break;
	       
       case 'K' : 
#ifdef MOVIE
               if (number >= 0) 
                 flags->frame_skip = number;
               else {
                 opt_error(optc);
                 usage();
               }
#endif
               break;

       case 'S' : 
#ifdef MOVIE
               if (number > 0) 
                 flags->frame_stride = number;
               else {
                 opt_error(optc);
                 usage();
               }
#endif
               break;

       case 'X' : 
#ifdef MOVIE
               if (number > 0) 
                 flags->max_frames = number;
               else {
                 opt_error(optc);
                 usage();
               }
#endif
               break;

       case '?' :
       default  :
               opt_error(optc);
               usage();
               break;

     } /* switch */

   } /* while */

}
