/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: parse_command_line.c,v $
 *
 * $Log: parse_command_line.c,v $
 * Revision 3.0  1994/11/21  brabec
 * *** empty log message ***
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "defs.h"
#include "types.h"
#include "protos.h"

#ifndef IBM_VERS
#include <getopt.h>
#endif

/*
 * This routine does three things: reads options from the ROTMOLE
 * environment varible, reads options from the command line, and
 * reads file names from the command line.
 *
 * Input: the command line, file name list, and flags
 * Output: changed file names and flags
 */

void parse_command_line( int argc, char **argv, FILE_INFO *filenames,
                         DRAW_FLAGS *flags)
{

   char *envopts,
        *argenv[2 * MAX_ENV_OPTS];

   int argenvct = 1;
   int numfile;

/* parse the ROTMOLE environment variable */

   if ((envopts = getenv("ROTMOLE")) != NULL) {
     if ((argenv[0] = strtok(envopts," ")) != NULL) {
       while ((argenv[argenvct] = strtok(NULL," ")) != NULL) {
         argenvct++;
 
         if (argenvct == 2 * MAX_ENV_OPTS) {
           fprintf(stderr, "ROTMOLE environment variable too long.\n");
           exit (-1);
         }
       }
 
       optind = 0; /* Reset Optind - internal to getopt */
       option_parser(argenvct,argenv,flags,filenames,"environment");
     }
   }

/* parse the command line options */
 
   optind = 1; /* Reset Optind - internal to getopt */
   option_parser(argc, argv, flags, filenames, "command line");

/* determine file names after all options have been processed */

   numfile = argc - optind;

/*
 * If more than two files are specified, gives the usage information.
 */

   if (numfile > 2)
     usage();

/* determine the data file name */

   if (numfile > 0) {
      if (strcmp(argv[optind],"-") != 0)       /* use stdin for '-' */
         set_string(&(filenames->position_fname),argv[optind]);
   }

/* determine the table file name */

   if (numfile > 1) {
      set_string(&(filenames->element_fname),argv[optind+1]);
   }

}


/* end of parse_command_line.cxx */
