/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: protos.h,v $
 *
 * $Log: protos.h,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

#include "vtkTransform.h"
#include "vtkRenderer.h"
#include "vtkRenderWindow.h"
#include "vtkCellPicker.h"
#include "vtkPolyDataMapper.h"

void *acquire( unsigned int );

ATOM_LIST *alloc_atom_list( );

FRAME_LIST *alloc_frame_list( );

void clear_bonds( FRAME_LIST * );

void color_setup( ELEMENT_LIST *, DRAW_FLAGS * );

void create_bond_table( FRAME_LIST * );

void debug_write_flags( DRAW_FLAGS * );


/*
void do_function_menu( long, FRAME_LIST *, FRAME_LIST *, DRAW_FLAGS *, 
                       ELEMENT_LIST *, WINDOW_IDS *, MENU_IDS * );
void do_popup_menu( long, FRAME_LIST *, FRAME_LIST *, ELEMENT_LIST *,
                    WINDOW_IDS *, MENU_IDS *, DRAW_FLAGS *, FILE_INFO * );
void do_popup_menu( int );
*/

void do_printsave_menu( long, FRAME_LIST *, WINDOW_IDS *, FILE_INFO * );

void do_reorient_model( WINDOW_IDS *, FRAME_LIST *, DRAW_FLAGS * );

void do_rotate_mode( WINDOW_IDS *, FRAME_LIST *, DRAW_FLAGS * );

/*
void do_toggle_menu( long, FRAME_LIST *, DRAW_FLAGS *, MENU_IDS *, 
                     WINDOW_IDS * );
*/

#ifdef MOVIE
void do_vcr_menu( WINDOW_IDS *, int, BUTTON_INFO *, VCR_FLAGS *, FRAME_LIST *,
                  FRAME_LIST *, FRAME_LIST **, DRAW_FLAGS * );
#endif

void do_zoom_mode( WINDOW_IDS *, FRAME_LIST *, DRAW_FLAGS * );

void draw_axes( float, COLOR );

void draw_bonds( BOND_LIST *, DRAW_FLAGS *, int, float * );

void draw_cylinder( float *, float *, long, float );

void draw_labelled_atom( ATOM_LIST *, DRAW_FLAGS *, float *, TOGGLE );

#ifdef MOVIE
void draw_frame_counter( int, DRAW_FLAGS * );

void draw_vcr_menu( int , BUTTON_INFO *, VCR_FLAGS * );
#endif

ELEMENT_LIST *find_element( ELEMENT_LIST *, char * );

char *get_filename( char *, char *, TOGGLE );

void get_first_model( FILE_INFO *, ELEMENT_LIST *, FRAME_LIST **, 
                      FRAME_LIST **, DRAW_FLAGS * );

void get_first_table( FILE_INFO *, ELEMENT_LIST * );

void get_front( float *, TOGGLE );

void get_max_radius( FRAME_LIST *, DRAW_FLAGS * );

void init_cursors ( );

void init_element_list( ELEMENT_LIST **, DRAW_FLAGS );

void init_gobjects( DRAW_FLAGS * );

void init_popups( MENU_IDS * );

void load_proj_matrix( WINDOW_IDS *, DRAW_FLAGS *, MENU_IDS *, char * );

void make_popups();

FILE * my_fopen( char *, char * );

#ifdef MOVIE
void open_windows( WINDOW_IDS *, VCR_INFO, BUTTON_INFO *, VCR_FLAGS * );
#else
void open_windows( WINDOW_IDS * );
#endif

void option_parser( int, char **, DRAW_FLAGS *, FILE_INFO *, char * );

void parse_command_line( int, char **, FILE_INFO *, DRAW_FLAGS * );

void read_new_table( ELEMENT_LIST *, TOGGLE * );

void recenter_model( FRAME_LIST *, FRAME_LIST *, DRAW_FLAGS * );

void reset_view( DRAW_FLAGS *, WINDOW_IDS * );

void rmtable_reader( FILE *, ELEMENT_LIST * );

void save_proj_matrix( WINDOW_IDS *, DRAW_FLAGS * );

void set_project( float, float, TOGGLE );

void set_string(char **, char *);

void update_window( WINDOW_IDS *, FRAME_LIST *, DRAW_FLAGS *, TOGGLE );

#ifdef MOVIE
void update_vcr_window( WINDOW_IDS *, FRAME_LIST *, VCR_FLAGS *, VCR_INFO *);
#endif

void usage();

void usleep( int );

void write_coord_file( int, FRAME_LIST *, FILE_INFO * );

void write_dx_format( int, FRAME_LIST *, FILE * );

void write_element_list( ELEMENT_LIST *, FILE * );

void write_rmf_format( FRAME_LIST *, FILE * );

void write_screen_image( int, WINDOW_IDS *, FILE_INFO * );


void mmode(short m);
void getmatrix(float m[4][4]);
void multmatrix(const float m[4][4]);
void loadmatrix(const float m[4][4]);

void trackball(float q[4], float p1x, float p1y, float p2x, float p2y);
void add_quats(float *q1, float *q2, float *dest);
void build_rotmatrix(float m[4][4], float q[4]);
void axis_to_quat(float a[3], float phi, float q[4]);

void rmf_reader( FILE *ifil, ELEMENT_LIST *element_head, 
                 FRAME_LIST **frame_head, FRAME_LIST **frame_tail, 
                 DRAW_FLAGS *flags );
int count_elements(ELEMENT_LIST *head);
void create_spheres(DRAW_FLAGS *flags, ELEMENT_LIST *element);
void create_bonds(DRAW_FLAGS *flags);
void create_labels(DRAW_FLAGS *flags, ELEMENT_LIST *element);
float distance(float x1, float y1, float z1, float x2, float y2, float z2);
float angle(float x1, float y1, float z1, float x2, float y2, float z2,
	    float x3, float y3, float z3);
void orient(float *rotations, float x1, float y1, float z1, float x2, float y2, float z2);
vtkTransform* getTransformation(float x1, float y1, float z1, float x2, float y2, float z2);
void delete_bonds(vtkRenderer *ren);
void delete_frame(vtkRenderer *ren);
void delete_axes(vtkRenderer *ren);
void delete_atoms(vtkRenderer *ren);
void delete_atom_labels(vtkRenderer *ren);
void delete_surfaces(vtkRenderer *ren);
void draw_frame(vtkRenderer *ren, vtkRenderWindow *renWindow, DRAW_FLAGS *flags,
		FRAME_LIST *frame, ELEMENT_LIST *element_head);
void draw_bonds(vtkRenderer *ren, DRAW_FLAGS *flags,
		FRAME_LIST *frame, ELEMENT_LIST *element_head);
void draw_atoms(vtkRenderer *ren, DRAW_FLAGS *flags, FRAME_LIST *frame);
void draw_axes(vtkRenderer *ren);
void draw_atom_labels(vtkRenderer *ren, DRAW_FLAGS *flags, ATOM_LIST *atoms);
void draw_isosurfaces(vtkRenderer *ren);
void change_sphere_complexity(vtkRenderWindow *renWindow, int complexity);
void change_bond_complexity(vtkRenderer *ren, vtkRenderWindow *renWindow, int complexity);
void init_mappers(DRAW_FLAGS *flags, ELEMENT_LIST *element_head);
void init_actors(vtkRenderer *ren, DRAW_FLAGS *flags, FRAME_LIST *frame, ELEMENT_LIST *element);
void open_density_file(char *filename);
void init_contour_filter();
void write_rmf(FRAME_LIST *cur, FILE *ofil);
ATOM_LIST *getPickedAtom(FRAME_LIST *frame, vtkCellPicker *picker, vtkPolyDataMapper *pickedMapper);
void clearPickedAtomArray(vtkRenderer *ren, FRAME_LIST *frame, ATOM_LIST *pickedAtoms[]);
void reportDistance(float x1, float y1, float z1, float x2,float  y2, float z2);
void reportAngle(float x1, float y1, float z1, float x2, float y2, float z2,
		 float x3, float y3, float z3);

/* end of protos.h */
