/*
 * Rotmole / Rotmovie source code
 *
 * $RCSfile: rmtable_reader.c,v $
 *
 * $Log: rmtable_reader.c,v $
 * Revision 3.0  1994/11/21 14:31:21  brabec
 * *** empty log message ***
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "defs.h"
#include "types.h"
#include "protos.h"

/*
 * This routine adds to or modifies the existing element list 
 * by adding or replacing from the opened file.
 *
 * Input: open element file, element list
 * Output: modified list
 */

/* length of lines to read */
#define LINLEN 150


void rmtable_reader(FILE *ifil, ELEMENT_LIST *head)
{

   TOGGLE done = false;

   float radius, red, green, blue;

   char label[LABEL_LEN+1];

   char lin[LINLEN], *index, *scanend;

   int pos;

   ELEMENT_LIST *current;


   while (!done) {

     fgets( lin, LINLEN, ifil );

/* commas to whitespace */
     for (index = lin; *index != 0; ++index)
       if (*index == ',') *index = ' ';

/* jump to first non-space character */
     for (index = lin; isspace((int) *index) && *index != '\n'; ++index)
       ; 

     if (feof(ifil) || index[0] == '/')
       done = true;

     else if ( index[0] == '#' )
       ; /* ignore comment line */

     else {   /* parse the item line */

/* first, get the atom label */
       for (pos=0; !isspace((int) index[pos]); pos++)
         ; /* scan to next whitespace */

       pos = (pos < LABEL_LEN ? pos : LABEL_LEN);

       strncpy(label, index, pos);
       label[pos] = 0;

/* Next, grab the numbers: rad, red, grn, blu */
       for ( ; !isspace((int) *index) && *index != '\n'; ++index)
         ; /* scan to next whitespace */

       radius = strtod(index, &scanend);

       index = scanend;
       red = strtod(index, &scanend);

       index = scanend;
       green = strtod(index, &scanend);

       index = scanend;
       blue = strtod(index, &scanend);

       if ((blue == 0) && (scanend == index)) {

         fprintf(stderr,"Error parsing line (ignored):\n%s\n",lin);

       } else {

/* find/add element in list, and set attributes */

         current = find_element(head, label);

         if (radius < 0.0) {
            current->radius = -radius;
            current->can_bond = false;
         } else {
            current->radius = radius;
            current->can_bond = true;
         }

         current->color.red   = red;
         current->color.green = green;
         current->color.blue  = blue;

       } /* else */

     } /* parse */

   } /* while */

}


/* end of rmtable_reader.cxx */
